import{s as Oe,n as Pe,o as ke}from"../chunks/scheduler.8c3d61f6.js";import{S as Ee,i as Le,g as a,s as r,r as l,A as Ie,h as d,f as t,c as o,j as D,u as p,x as H,k as T,y as s,a as u,v as m,d as f,t as h,w as g}from"../chunks/index.da70eac4.js";import{D as j}from"../chunks/Docstring.6b390b9a.js";import{H as ve,E as Me}from"../chunks/EditOnGithub.1e64e623.js";function Ne(xe){let _,R,B,G,w,Y,y,$e='The Heun scheduler (Algorithm 1) is from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper by Karras et al. The scheduler is ported from the <a href="https://github.com/crowsonkb/k-diffusion" rel="nofollow">k-diffusion</a> library and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',J,C,Q,i,O,de,q,Se="Scheduler with Heun steps for discrete beta schedules.",ce,F,De=`This model inherits from <a href="/docs/diffusers/v0.31.0/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/v0.31.0/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,ue,v,P,le,V,He=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,pe,x,k,me,A,Te="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",fe,$,E,he,U,we="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",ge,S,L,_e,z,ye=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,X,I,Z,b,M,be,W,Ce="Base class for the output of a scheduler’s <code>step</code> function.",ee,N,te,K,se;return w=new ve({props:{title:"HeunDiscreteScheduler",local:"heundiscretescheduler",headingTag:"h1"}}),C=new ve({props:{title:"HeunDiscreteScheduler",local:"diffusers.HeunDiscreteScheduler",headingTag:"h2"}}),O=new j({props:{name:"class diffusers.HeunDiscreteScheduler",anchor:"diffusers.HeunDiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": Union = None"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"use_karras_sigmas",val:": Optional = False"},{name:"use_exponential_sigmas",val:": Optional = False"},{name:"use_beta_sigmas",val:": Optional = False"},{name:"clip_sample",val:": Optional = False"},{name:"clip_sample_range",val:": float = 1.0"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.HeunDiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.HeunDiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.HeunDiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.HeunDiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.HeunDiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.HeunDiscreteScheduler.clip_sample",description:`<strong>clip_sample</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Clip the predicted sample for numerical stability.`,name:"clip_sample"},{anchor:"diffusers.HeunDiscreteScheduler.clip_sample_range",description:`<strong>clip_sample_range</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The maximum magnitude for sample clipping. Valid only when <code>clip_sample=True</code>.`,name:"clip_sample_range"},{anchor:"diffusers.HeunDiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.HeunDiscreteScheduler.use_exponential_sigmas",description:`<strong>use_exponential_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use exponential sigmas for step sizes in the noise schedule during the sampling process.`,name:"use_exponential_sigmas"},{anchor:"diffusers.HeunDiscreteScheduler.use_beta_sigmas",description:`<strong>use_beta_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use beta sigmas for step sizes in the noise schedule during the sampling process. Refer to <a href="https://huggingface.co/papers/2407.12173" rel="nofollow">Beta
Sampling is All You Need</a> for more information.`,name:"use_beta_sigmas"},{anchor:"diffusers.HeunDiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.HeunDiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/v0.31.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L95"}}),P=new j({props:{name:"scale_model_input",anchor:"diffusers.HeunDiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": Tensor"},{name:"timestep",val:": Union"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.HeunDiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/v0.31.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L237",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),k=new j({props:{name:"set_begin_index",anchor:"diffusers.HeunDiscreteScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/v0.31.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L227"}}),E=new j({props:{name:"set_timesteps",anchor:"diffusers.HeunDiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": Optional = None"},{name:"device",val:": Union = None"},{name:"num_train_timesteps",val:": Optional = None"},{name:"timesteps",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"},{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The number of diffusion steps used when training the model. If <code>None</code>, the default
<code>num_train_timesteps</code> attribute is used.`,name:"num_train_timesteps"},{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps used to support arbitrary spacing between timesteps. If <code>None</code>, timesteps will be
generated based on the <code>timestep_spacing</code> attribute. If <code>timesteps</code> is passed, <code>num_inference_steps</code>
must be <code>None</code>, and <code>timestep_spacing</code> attribute will be ignored.`,name:"timesteps"}],source:"https://github.com/huggingface/diffusers/blob/v0.31.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L263"}}),L=new j({props:{name:"step",anchor:"diffusers.HeunDiscreteScheduler.step",parameters:[{name:"model_output",val:": Union"},{name:"timestep",val:": Union"},{name:"sample",val:": Union"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.HeunDiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.HeunDiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.HeunDiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <code>HeunDiscreteSchedulerOutput</code> or
tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/v0.31.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L472",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <code>HeunDiscreteSchedulerOutput</code> is
returned, otherwise a tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>HeunDiscreteSchedulerOutput</code> or <code>tuple</code></p>
`}}),I=new ve({props:{title:"SchedulerOutput",local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",headingTag:"h2"}}),M=new j({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": Tensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.31.0/src/diffusers/schedulers/scheduling_utils.py#L60"}}),N=new Me({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/schedulers/heun.md"}}),{c(){_=a("meta"),R=r(),B=a("p"),G=r(),l(w.$$.fragment),Y=r(),y=a("p"),y.innerHTML=$e,J=r(),l(C.$$.fragment),Q=r(),i=a("div"),l(O.$$.fragment),de=r(),q=a("p"),q.textContent=Se,ce=r(),F=a("p"),F.innerHTML=De,ue=r(),v=a("div"),l(P.$$.fragment),le=r(),V=a("p"),V.textContent=He,pe=r(),x=a("div"),l(k.$$.fragment),me=r(),A=a("p"),A.textContent=Te,fe=r(),$=a("div"),l(E.$$.fragment),he=r(),U=a("p"),U.textContent=we,ge=r(),S=a("div"),l(L.$$.fragment),_e=r(),z=a("p"),z.textContent=ye,X=r(),l(I.$$.fragment),Z=r(),b=a("div"),l(M.$$.fragment),be=r(),W=a("p"),W.innerHTML=Ce,ee=r(),l(N.$$.fragment),te=r(),K=a("p"),this.h()},l(e){const n=Ie("svelte-u9bgzb",document.head);_=d(n,"META",{name:!0,content:!0}),n.forEach(t),R=o(e),B=d(e,"P",{}),D(B).forEach(t),G=o(e),p(w.$$.fragment,e),Y=o(e),y=d(e,"P",{"data-svelte-h":!0}),H(y)!=="svelte-1r9m54f"&&(y.innerHTML=$e),J=o(e),p(C.$$.fragment,e),Q=o(e),i=d(e,"DIV",{class:!0});var c=D(i);p(O.$$.fragment,c),de=o(c),q=d(c,"P",{"data-svelte-h":!0}),H(q)!=="svelte-1k165jq"&&(q.textContent=Se),ce=o(c),F=d(c,"P",{"data-svelte-h":!0}),H(F)!=="svelte-1ig3u55"&&(F.innerHTML=De),ue=o(c),v=d(c,"DIV",{class:!0});var ne=D(v);p(P.$$.fragment,ne),le=o(ne),V=d(ne,"P",{"data-svelte-h":!0}),H(V)!=="svelte-1rkfgpx"&&(V.textContent=He),ne.forEach(t),pe=o(c),x=d(c,"DIV",{class:!0});var re=D(x);p(k.$$.fragment,re),me=o(re),A=d(re,"P",{"data-svelte-h":!0}),H(A)!=="svelte-1k141rk"&&(A.textContent=Te),re.forEach(t),fe=o(c),$=d(c,"DIV",{class:!0});var oe=D($);p(E.$$.fragment,oe),he=o(oe),U=d(oe,"P",{"data-svelte-h":!0}),H(U)!=="svelte-1vzm9q"&&(U.textContent=we),oe.forEach(t),ge=o(c),S=d(c,"DIV",{class:!0});var ie=D(S);p(L.$$.fragment,ie),_e=o(ie),z=d(ie,"P",{"data-svelte-h":!0}),H(z)!=="svelte-hi84tp"&&(z.textContent=ye),ie.forEach(t),c.forEach(t),X=o(e),p(I.$$.fragment,e),Z=o(e),b=d(e,"DIV",{class:!0});var ae=D(b);p(M.$$.fragment,ae),be=o(ae),W=d(ae,"P",{"data-svelte-h":!0}),H(W)!=="svelte-6ojmkw"&&(W.innerHTML=Ce),ae.forEach(t),ee=o(e),p(N.$$.fragment,e),te=o(e),K=d(e,"P",{}),D(K).forEach(t),this.h()},h(){T(_,"name","hf:doc:metadata"),T(_,"content",qe),T(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(i,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,n){s(document.head,_),u(e,R,n),u(e,B,n),u(e,G,n),m(w,e,n),u(e,Y,n),u(e,y,n),u(e,J,n),m(C,e,n),u(e,Q,n),u(e,i,n),m(O,i,null),s(i,de),s(i,q),s(i,ce),s(i,F),s(i,ue),s(i,v),m(P,v,null),s(v,le),s(v,V),s(i,pe),s(i,x),m(k,x,null),s(x,me),s(x,A),s(i,fe),s(i,$),m(E,$,null),s($,he),s($,U),s(i,ge),s(i,S),m(L,S,null),s(S,_e),s(S,z),u(e,X,n),m(I,e,n),u(e,Z,n),u(e,b,n),m(M,b,null),s(b,be),s(b,W),u(e,ee,n),m(N,e,n),u(e,te,n),u(e,K,n),se=!0},p:Pe,i(e){se||(f(w.$$.fragment,e),f(C.$$.fragment,e),f(O.$$.fragment,e),f(P.$$.fragment,e),f(k.$$.fragment,e),f(E.$$.fragment,e),f(L.$$.fragment,e),f(I.$$.fragment,e),f(M.$$.fragment,e),f(N.$$.fragment,e),se=!0)},o(e){h(w.$$.fragment,e),h(C.$$.fragment,e),h(O.$$.fragment,e),h(P.$$.fragment,e),h(k.$$.fragment,e),h(E.$$.fragment,e),h(L.$$.fragment,e),h(I.$$.fragment,e),h(M.$$.fragment,e),h(N.$$.fragment,e),se=!1},d(e){e&&(t(R),t(B),t(G),t(Y),t(y),t(J),t(Q),t(i),t(X),t(Z),t(b),t(ee),t(te),t(K)),t(_),g(w,e),g(C,e),g(O),g(P),g(k),g(E),g(L),g(I,e),g(M),g(N,e)}}}const qe='{"title":"HeunDiscreteScheduler","local":"heundiscretescheduler","sections":[{"title":"HeunDiscreteScheduler","local":"diffusers.HeunDiscreteScheduler","sections":[],"depth":2},{"title":"SchedulerOutput","local":"diffusers.schedulers.scheduling_utils.SchedulerOutput","sections":[],"depth":2}],"depth":1}';function Fe(xe){return ke(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class We extends Ee{constructor(_){super(),Le(this,_,Fe,Ne,Oe,{})}}export{We as component};
